#include<limits.h>
#include <stdio.h>
#include <stdlib.h>
#include "Life.h"


#include <X11/Xlib.h> // Every Xlib program must include this
#include <assert.h>   // I include this to test return values the lazy way
#include<sys/time.h>
#include<sys/resource.h>
#include <unistd.h>   // So we got the profile for 10 seconds

#define NIL (0)       // A name for the void pointer

int main (int argc, char** argv) {
  int i, j, iterador;
  long colunas, linhas, iteracoes;
  char **gradeAtual, **proximaGrade;
  char *fname;

  struct rusage usage, prev_usage;

  double tempo_gasto;  

  if (argc != 5) {
    printf("<Arquivo> <linhas> <colunas> <iteracoes>\n");
    exit(1);
  }
  iterador=0;
  
  
  fname = argv[1];
  linhas=atoi(argv[2]);
  colunas=atoi(argv[3]);
  iteracoes=atoi(argv[4]);
    
  gradeAtual= alocaGrade(gradeAtual, colunas, linhas);
   
  (void) loadData(fname, linhas, colunas, gradeAtual);  
 
  proximaGrade=alocaGrade(proximaGrade, colunas, linhas);
    
  imprimeResultado (gradeAtual,colunas,linhas);
   
  //setupWindow(colunas,linhas);

  //tinicial = (double) (clock()/CLOCKS_PER_SEC); //INICIO DO TEMPO
 
  getrusage(RUSAGE_SELF, &prev_usage);
   
  while (iterador<iteracoes) {
    aplicaConway (gradeAtual,proximaGrade,colunas,linhas);

    //imprimeResultado(proximaGrade,colunas,linhas);

    for (i=0;i<(linhas+2);i++)
      for (j = 0; j<(colunas+2);j++) gradeAtual[i][j]=proximaGrade[i][j];

    iterador++;
    //doDraw(iterador, colunas, linhas, gradeAtual);
  }

  imprimeResultado(gradeAtual,colunas,linhas);
  //tfinal = (double) (clock()/CLOCKS_PER_SEC); //FIM DO TEMPO


  getrusage(RUSAGE_SELF, &usage);	  
  tempo_gasto = (((double)usage.ru_utime.tv_sec+((double)usage.ru_utime.tv_usec/1e06))-((double)prev_usage.ru_utime.tv_sec+((double)prev_usage.ru_utime.tv_usec/10e06)));
  printf ("O tempo de processamento de usuario  de : %f\n", tempo_gasto);
    
  /*
  tempo_gasto = (double)(tfinal - tinicial);
  printf ("O tempo gasto para o computo  de : %g\n", tempo_gasto);
  printf ("iteracoes-iterador : %d\n", iteracoes-iterador);
  */
 
  liberaGrade(gradeAtual,linhas);
  liberaGrade(proximaGrade,linhas);
  return 0;

}

void *mallocX (unsigned int nbytes) 
{
  void *ptr;
  ptr = malloc (nbytes);
  if (ptr == NULL) {
    printf ("Socorro! malloc devolveu NULL!\n");
    exit (EXIT_FAILURE);
  }
  return ptr;
}

char **alocaGrade (char **grade, long ncols, long nlins) {
  int i, j;
  grade = (char **)mallocX((nlins+2)*sizeof(char*));
  for (i = 0;i<=(nlins+1);i++) {
    grade[i] = (char *)mallocX((ncols+2));
  }
  for (j=0;j<ncols+2;j++)grade[0][j]=65;
  for (j=0;j<ncols+2;j++)grade[nlins+1][j]=65;
  for (i=1;i<nlins+1;i++)grade[i][0]=65;
  for (i=1;i<nlins+1;i++)grade[i][ncols+1]=65;
  
  for(i=1;i<=nlins;i++)
    for(j=1;j<=ncols;j++)
      grade[i][j]=48;
  
  return grade;
}

void liberaGrade(char ** grade, long nlins){
  int i;
  for (i=0; i<(nlins+2);i++) {
    free(grade[i]);
  }
  free(grade);
}

void imprimeResultado (char** grade, long ncols, long nrows) {
  int i, j;
  for (i=0;i<=(nrows+1);i++){
    for (j=0;j<=(ncols+1);j++){
      if (i == 0 || j == 0 || (i == nrows+1) || (j == ncols+1))
	printf ("%c", grade[i][j]);
      else if (grade[i][j] == 49) printf ("V");
      else printf ("M");
    }
    printf("\n");
  }
  printf("\n\n");
}

int calculaVizinho(char **grade, int i, int j) {
  
  int numeroDeVizinho = 0;
  
  if (grade[i-1][j-1] == 49) numeroDeVizinho++;
  if (grade[i][j-1] == 49) numeroDeVizinho++;
  if (grade[i-1][j] == 49) numeroDeVizinho++;
  if (grade[i-1][j+1] == 49) numeroDeVizinho++; 
  if (grade[i+1][j-1] == 49) numeroDeVizinho++;
  if (grade[i][j+1] == 49) numeroDeVizinho++;
  if (grade[i+1][j] == 49) numeroDeVizinho++;
  if (grade[i+1][j+1] == 49) numeroDeVizinho++;
  return numeroDeVizinho;
}

void aplicaConway (char**gradeAtual, char**proximaGrade, long numCols, long numLins) {
  int i, j;
  int vizinhos;
  
  for (i=1; i<=numLins; i++)
    for (j=1;j<=numCols;j++) {
      vizinhos = calculaVizinho(gradeAtual,i,j);

      //Se a celula eh viva
      if (gradeAtual[i][j]=='1') {
         if (vizinhos != 2 && vizinhos != 3) proximaGrade[i][j] = 48;
         else proximaGrade[i][j] = 49;
      }

      //Se a celula eh morta
      else {
         if (vizinhos == 3) proximaGrade[i][j] = 49;
         else proximaGrade[i][j] = 48;
      }
    }
}


int loadData(char *fname, int nrows, int ncols, char **grid)
{
  FILE *fp; 
  int i, j;
 
  fp = fopen (fname, "r");
  if (fp == NULL) {
    printf ("Erro na abertura do arquivo %s.\n", fname);
    return EXIT_FAILURE;
  }

  printf("\nLoading data from file '%s'\n", fname);
  
  /* leitura da matriz */
  for (i = 1; i < nrows+1; i++) {
    for (j = 1; j < ncols+1; j++)
      if (fscanf (fp, "%c ", &grid[i][j]) != 1) {
        printf ("O arquivo %s  no est completo ou "
                "possui algum smbolo invlido.\n", fname);
        return -1;
      }
  }
  fclose (fp);
  return 0;
}


Display *dpy;
int blackColor;
int whiteColor;
Window w;
GC gc;
Pixmap buffer;
Colormap theColormap;
int numXGrayscale=10;
XColor Xgrayscale[10];
int IMAGE_WIDTH=LIFE_IMAGE_WIDTH;
int IMAGE_HEIGHT=LIFE_IMAGE_HEIGHT;

void setupWindow(int ncols, int nrows) {
  // Open the display
  int i;
  dpy = XOpenDisplay(NIL);
  assert(dpy);
  
  // Get some colors
  
 
  blackColor = BlackPixel(dpy, DefaultScreen(dpy));
  whiteColor = WhitePixel(dpy, DefaultScreen(dpy));
   
  // Create the window
  if (nrows>ncols) {
    printf ("Howdy\n");
    IMAGE_WIDTH = (int)((double)LIFE_IMAGE_WIDTH*(double)ncols/(double)nrows);
    IMAGE_HEIGHT = LIFE_IMAGE_HEIGHT;
  } else {
    IMAGE_HEIGHT = (int)((double)LIFE_IMAGE_HEIGHT*(double)nrows/(double)ncols);
    IMAGE_WIDTH = LIFE_IMAGE_WIDTH;
  }
  
  
  w = XCreateSimpleWindow(dpy, DefaultRootWindow(dpy), 0, 0, 
			  IMAGE_WIDTH, IMAGE_HEIGHT, 0, blackColor,
			  blackColor);
  buffer = XCreatePixmap(dpy,DefaultRootWindow(dpy),
			 IMAGE_WIDTH,IMAGE_HEIGHT,DefaultDepth(dpy,
							       DefaultScreen(dpy)));
  
  theColormap = XCreateColormap(dpy, DefaultRootWindow(dpy),
				DefaultVisual(dpy,DefaultScreen(dpy)), AllocNone);
  
  for (i=0;i<numXGrayscale;i++) {
    int color = (int)((double)i*35535.0/(double)numXGrayscale)+30000;
    Xgrayscale[i].red=color;
    Xgrayscale[i].green=color;
    Xgrayscale[i].blue=color;
    XAllocColor(dpy,theColormap,&(Xgrayscale[i]));
  }
  
  XSelectInput(dpy, w, StructureNotifyMask);
  
  //faa janela aparecer no ecran
  
  XMapWindow(dpy, w);
  
  // criar contexto grafico
  
  gc = XCreateGC(dpy, w, 0, NIL);
  
  // Tell the GC we draw using the white color
  
  XSetForeground(dpy, gc, whiteColor);
  
  // Wait for the MapNotify event
  
  for(;;) {
    XEvent e;
    XNextEvent(dpy, &e);
    if (e.type == MapNotify)
      break;
  }
  
}

void doDraw(int rank, int ncols, int nrows, char ** grid) {
  
  int x1,x2,y1,y2;
  int i, j; 
  char string[4];
  sprintf(string,"%d",rank);
  
  XSetForeground(dpy, gc, blackColor);
  XFillRectangle(dpy,buffer,gc,0,0,IMAGE_WIDTH,IMAGE_HEIGHT);
  int rect_width=(int)((double)IMAGE_WIDTH/(double)(nrows+1));
  int rect_height=(int)((double)IMAGE_HEIGHT/(double)(ncols+1));
  for (i=1;i<=nrows;i++) {
    x1 = (int)((double)(i-1)/(double)(nrows+1)*(double)IMAGE_WIDTH);
    for (j=1;j<=ncols;j++) {
      y1 = (int)((double)(j-1)/(double)(ncols+1)*
		 (double)IMAGE_HEIGHT);
      if (grid[i][j]==49) {
	char life = grid[i][j];
	if (life>numXGrayscale-1) life = numXGrayscale-1;
	XSetForeground(dpy, gc, Xgrayscale[life].pixel);
      } else {
	XSetForeground(dpy, gc, blackColor);
      }
      XFillRectangle(dpy,buffer,gc,x1,y1,rect_width,rect_height);
    }
  }
  XSetForeground(dpy,gc,blackColor);
  XFillRectangle(dpy,buffer,gc,10,10,16,16);
  XSetForeground(dpy,gc,whiteColor);
  XDrawRectangle(dpy,buffer,gc,10,10,16,16);
  XDrawString(dpy,buffer,gc,12,23,string,4);
  
  XCopyArea(dpy, buffer, w, gc, 0, 0,
	    IMAGE_WIDTH, IMAGE_HEIGHT,  0, 0);
  XFlush(dpy); 
}
